import * as mc from '@minecraft/server'
import * as config from './config.js'


mc.world.beforeEvents.chatSend.subscribe((eventData) => {
    const player = eventData.sender;
    const msg = eventData.message;

    // Handle case for players without ranks
    if (!player.getTags().find(tag => tag.startsWith('simplerank:'))) {
        eventData.cancel = true;
        mc.world.sendMessage(`§8[${config.memberRankColour}§r§r§8]§7 ${player.name} §8>>§7 ${msg}`);
        return;
    }

    // Get all ranks
    let ranks = player.getTags()
        .filter(tag => tag.startsWith('simplerank:'))
        .map(tag => tag.substring(11));  // Assuming 'simplerank:' prefix is exactly 11 characters

    // If player has ranks and chat ranks are enabled
    if (ranks.length > 0) {
        let joinedRanks = ranks.join('§r§8] [§r');  // Join ranks with specific formatting

        // Fetching other possible tags (name color and chat color)
        const simpleNcTag = player.getTags().find(tag => tag.startsWith('simple-nc:'));
        let simpleNcDisplay = simpleNcTag ? simpleNcTag.split('simple-nc:')[1] : '';

        const simpleCCTag = player.getTags().find(tag => tag.startsWith('simple-cc:'));
        let simpleCCDisplay = simpleCCTag ? simpleCCTag.split('simple-cc:')[1] : '';

        eventData.cancel = true;

        // Replacing `{nl}` with a new line if it exists in the message
        let formattedMessage = msg.replaceAll("{nl}", "\n");

        // Send the formatted message with ranks and player name
        mc.world.sendMessage(`§8[§r${joinedRanks}§r§8]§7 ${simpleNcDisplay}${player.name} §8>>§7${simpleCCDisplay} ${formattedMessage}`);
    }
});
